#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <fcntl.h>
#include <sys/shm.h>
#include <sys/file.h>
#include "config.h"
#include <semaphore.h>
#include <sys/sem.h>
#include <string.h>
#include <sys/types.h>

sem_t* semaphore;

void critical_section(int i){  //Critical section where the cstest is opened and written into with the time string
          sem_wait(semaphore);
          FILE* file = fopen("cstest", "a");
                        if(file){
                                time_t t;
                                struct tm *tm_info;

                                time(&t);
                                tm_info = localtime(&t);

                                char timeStr[9]; //HH:MM:SS
                                strftime(timeStr, sizeof(timeStr), "%H:%M:%S", tm_info);
                                fprintf(file, "%s Process %02d entered the critical section:\n", timeStr, i);
                                fclose(file);
                        } else {
                                perror("File failed to open");
                        }
        sem_post(semaphore);
}

void process(int i){ //Function to allow one process to access the critical section at the time

        int k;
        for(k = 0; k < 5; k++){ //Loop to limit each process to five entries
                wait_semaphore();

                        char logFile[20];
                        sprintf(logFile, "logfile.%02d", i); //Creating logfiles for each processes
                        FILE* log = fopen(logFile, "a"); //Opening log files

                        if(log){
                        time_t t;
                        struct tm *tm_info;

                        memset ( &t, '\0', sizeof ( t ));
                        time(&t);
                        tm_info = localtime(&t);

                        char timeStr[9]; //HH:MM:SS
                        strftime(timeStr, sizeof(timeStr), "%H:%M:%S", tm_info);
                        fprintf(log, "%s Process %02d entered the critical section\n", timeStr, i); //Outputs the time when entering the critical section

                
                        } else {
                                perror("File failed to open");
                        }

                        sem_wait(semaphore);

                        sleep(rand() % 3 + 1);

                        critical_section(semaphore, i);

                        sem_post(semaphore);

                        log = fopen(logFile, "a");
                                if(log){
                                time_t t;
                                struct tm *tm_info;

                                memset ( &t, '\0', sizeof ( t ));
                                time(&t);
                                tm_info = localtime(&t);

                                char timeStr[9]; //HH:MM:SS
                                strftime(timeStr, sizeof(timeStr), "%H:%M:%S", tm_info);
                                fprintf(log, "%s Process %02d exited the critical section\n", timeStr, i); //Outputs the time when exiting the critical section
                                fclose(log);
                                } else {
                                        perror("File failed to open");
                                }

                        sleep(rand() % 3 + 1);

                }
        }


int main(int argc, char *argv[]) {
        int n;
        int pid_logical = atoi(argv[1]);  //Accessing the child processes from argv1

        srand(time(NULL) +getpid());  //Generating random seed
      
        key_t key = ftok("shmfile", 65);
        int shm_id = shmget(key, sizeof(int), 0666);
        int *shared_data = (int *)shmat(shm_id, NULL, 0);

        key_t keySem = ftok("shmfile1", 65);
        int sem_id = semget(keySem, 1, 0666);
        if(sem_id == -1){
                perror("WE ARE HEREsemget");
                exit(EXIT_FAILURE);
        }
        semctl(sem_id, 0, 1);
        if(sem_id < 0){
                perror("did not attach");
                exit(EXIT_FAILURE);
        }

      
        process(pid_logical);

        printf("Slave %d: Shared data: %d\n", pid_logical, *shared_data);
        
        shmdt(shared_data);
        if(shmctl(shm_id, IPC_RMID, NULL) == -1){
                perror("Error deallocating shared memory");
                exit(EXIT_FAILURE);
        }

        if(semctl(sem_id, 0, IPC_RMID, 0) == -1){
                perror("semtcl IPC_RMID");
                exit(EXIT_FAILURE);
        }



 return 0; 
}
